<?php
/**
 * CSE154 19sp Final Exam Problem 4 (PHP) Solution
 */

// Part C
if (!isset($_GET["mode"]) || 
   ($_GET["mode"] !== "all" && $_GET["mode"] !== "lookup")) {
  handle_error("Please pass in a mode of all or lookup.");
}

$mode = $_GET["mode"];

if ($mode === "all") { // Query 1
  header("Content-type: text/plain");
  echo get_list();
} else if ($mode === "lookup") { // Query 2
  if (!isset($_GET["name"])) {
    handle_error("Please pass in a character name to lookup");
  }
  $name = $_GET["name"];
  $info = get_info($name);
  header("Content-type: application/json");
  echo $info;
}

function handle_error($error) {
  header("Content-type: text/plain");
  header("HTTP/1.1 400 Invalid Request");
  die($error);
}

// Part A
function get_list() {
  $files = glob("data/*");
  $result = "";
  for ($i = 0; $i < count($files); $i++) {
    $result = $result . basename($files[$i]) . "\n";
  }
  return $result;
}

// Part B
function get_info($char_dir) {
  $contents = file("data/$char_dir/info.txt", FILE_IGNORE_NEW_LINES);
  $results = array(
    "name" => $contents[0],
    "series" => $contents[1],
    "description" => $contents[2]
  );
  $results["appearances"] = file("data/$char_dir/appearances.txt", FILE_IGNORE_NEW_LINES);
  return json_encode($results);
}
